﻿using System.Diagnostics;
using System.Linq;
using System.Net.Security;

namespace RS6Sample2
{
	// Sample demonstrating different behaviour for hint
	// "Method with params invoked. Have you intended to call more specific method"

   public class Class1
   {
      private static readonly int _processId = Process.GetCurrentProcess().Id;

      private static readonly RemoteCertificateValidationCallback
          _disableSslCertificateCheck =
              (sender, certificate, chain, sslErrors) =>
              {
                 var traceSource = new TraceSource("*");

					  if (sslErrors == SslPolicyErrors.RemoteCertificateChainErrors)
                 {
						  // RS 6.0 does mark this statement ============================
						  var items =
                        chain.ChainStatus.Select(
                            status => string.Format(
                                null,
                                "Status:{0} StatusInformation: {1}",
                                status.Status,
                                status.StatusInformation
                                )
                            );
                    foreach (var item in items)
                    {
                       traceSource.TraceEvent(TraceEventType.Warning, _processId, item);
                    }
                 }

					  // RS 6.0 does not mark this statement, although IMHO it should be marked, too =====================
					  var message = string.Format(
                     null,
                     "X509v3 ### Subject:{0} Issuer:{1} Certificate status:{2}",
                     certificate.Subject,
                     certificate.Issuer,
                     sslErrors
                     );
                 traceSource.TraceEvent(TraceEventType.Warning, _processId, message);
                 return true;
              };
   }
}
